"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var libs_1 = require("./libs");
var execa = require('execa');
function run(command, options) {
    if (options === void 0) { options = {}; }
    return invoke(command, options);
}
exports.run = run;
function run$(command) {
    var subject = new libs_1.Subject();
    var child = invoke(command, { silent: true });
    var next = function (data, isError) {
        return subject.next({
            text: data.toString(),
            isError: isError,
        });
    };
    child.stdout.on('data', function (data) { return next(data, false); });
    child.stderr.on('data', function (data) { return next(data, true); });
    return subject;
}
exports.run$ = run$;
function invoke(cmd, options) {
    if (options === void 0) { options = {}; }
    var _a = options.silent, silent = _a === void 0 ? false : _a;
    var promise = execa.shell(cmd);
    if (!silent) {
        promise.stdout.pipe(process.stdout);
    }
    return promise;
}
function inNewTab(cmd, path) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var command;
        return tslib_1.__generator(this, function (_a) {
            command = "osascript -e '\n    if application \"iTerm\" is running then\n      tell application \"iTerm\"\n          tell current window\n              create tab with default profile\n              tell current session\n                  write text \"cd " + path + " && clear && " + cmd + "\"\n              end tell\n          end tell\n      end tell\n    else\n        activate application \"iTerm\"\n    end if\n  '";
            return [2, run(command, { silent: true })];
        });
    });
}
exports.inNewTab = inNewTab;
//# sourceMappingURL=util.exec.js.map