"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var glob_1 = require("glob");
var libs_1 = require("./libs");
function glob(pattern, options) {
    if (options === void 0) { options = {}; }
    return new Promise(function (resolve, reject) {
        new glob_1.Glob(pattern, options, function (err, matches) {
            if (err) {
                reject(err);
            }
            else {
                resolve(matches);
            }
        });
    });
}
exports.glob = glob;
function findClosestAncestor(startDir, fileName) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var find;
        var _this = this;
        return tslib_1.__generator(this, function (_a) {
            find = function (dir) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                var path;
                return tslib_1.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!dir || dir === '/') {
                                return [2];
                            }
                            path = libs_1.fsPath.join(dir, fileName);
                            return [4, libs_1.fs.pathExists(path)];
                        case 1: return [2, (_a.sent()) ? path : find(libs_1.fsPath.resolve(dir, '..'))];
                    }
                });
            }); };
            return [2, find(startDir)];
        });
    });
}
exports.findClosestAncestor = findClosestAncestor;
function watch(pattern) {
    var subject = new libs_1.Subject();
    libs_1.chokidar.watch(pattern).on('change', function (path) { return subject.next(path); });
    return subject.asObservable();
}
exports.watch = watch;
function yaml(filePath) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var path, subpath, setIfExists, text, res, error_1;
        var _this = this;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    path = '';
                    subpath = filePath.substring(0, filePath.length - libs_1.fsPath.extname(filePath).length);
                    setIfExists = function (ext) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                        var test;
                        return tslib_1.__generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (path) {
                                        return [2];
                                    }
                                    test = "" + subpath + ext;
                                    return [4, libs_1.fs.pathExists(test)];
                                case 1:
                                    path = (_a.sent()) ? test : path;
                                    return [2];
                            }
                        });
                    }); };
                    return [4, setIfExists('.yml')];
                case 1:
                    _a.sent();
                    return [4, setIfExists('.yaml')];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4, libs_1.fs.readFile(path)];
                case 4:
                    text = (_a.sent()).toString();
                    res = libs_1.jsYaml.safeLoad(text);
                    return [2, res];
                case 5:
                    error_1 = _a.sent();
                    throw new Error("Failed to load YAML file '" + filePath + "'. " + error_1.message);
                case 6: return [2];
            }
        });
    });
}
exports.yaml = yaml;
//# sourceMappingURL=util.file.js.map