"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants = require("./constants");
var libs_1 = require("./libs");
exports.compact = function (value) {
    return libs_1.R.pipe(libs_1.R.reject(libs_1.R.isNil), libs_1.R.reject(libs_1.R.isEmpty))(value);
};
function toGroupedCommands(commands) {
    var commandList = Object.keys(commands).map(function (key) { return commands[key]; });
    var groups = libs_1.R.uniq(commandList.map(function (cmd) { return cmd.group || constants.DEFAULT_GROUP; })).sort();
    var grouped = { __default__: {} };
    groups.forEach(function (group) { return (grouped[group] = {}); });
    groups.forEach(function (group) {
        var isInGroup = function (cmd) {
            return (cmd.group || constants.DEFAULT_GROUP) === group;
        };
        var groupCommands = libs_1.R.sortBy(libs_1.R.prop('name'), commandList.filter(isInGroup));
        groupCommands.forEach(function (cmd) { return (grouped[group][cmd.name] = cmd); });
    });
    return grouped;
}
exports.toGroupedCommands = toGroupedCommands;
//# sourceMappingURL=util.js.map