"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var util_pluralize_1 = require("./util.pluralize");
describe('pluralize', function () {
    it('handles empty-string', function () {
        chai_1.expect(util_pluralize_1.plural('')).to.equal('');
        chai_1.expect(util_pluralize_1.singular('')).to.equal('');
    });
    it('handles undefined', function () {
        chai_1.expect(util_pluralize_1.plural()).to.equal(undefined);
        chai_1.expect(util_pluralize_1.singular()).to.equal(undefined);
    });
    it('handles null', function () {
        chai_1.expect(util_pluralize_1.plural(null)).to.equal(null);
        chai_1.expect(util_pluralize_1.singular(null)).to.equal(null);
    });
    it('converts to plural', function () {
        chai_1.expect(util_pluralize_1.plural('cat')).to.equal('cats');
        chai_1.expect(util_pluralize_1.plural('cat', 2)).to.equal('cats');
        chai_1.expect(util_pluralize_1.plural('cat', 1)).to.equal('cat');
        chai_1.expect(util_pluralize_1.plural('cat', 0)).to.equal('cats');
    });
    it('does not add "s" to plural of sheep', function () {
        chai_1.expect(util_pluralize_1.plural('sheep')).to.equal('sheep');
        chai_1.expect(util_pluralize_1.plural('sheep', 2)).to.equal('sheep');
        chai_1.expect(util_pluralize_1.plural('sheep', 1)).to.equal('sheep');
        chai_1.expect(util_pluralize_1.plural('sheep', 0)).to.equal('sheep');
    });
    it('singularizes a word', function () {
        chai_1.expect(util_pluralize_1.singular('cows')).to.equal('cow');
        chai_1.expect(util_pluralize_1.singular('cow')).to.equal('cow');
    });
});
//# sourceMappingURL=util.pluralize.test.js.map