"use strict";
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var command_1 = require("./command");
var common_1 = require("./common");
function toCommand(modulePath) {
    var m = require(modulePath);
    var name;
    name = m.name ? m.name : common_1.fsPath.basename(modulePath, '.js');
    name = name.endsWith('.cmd') ? common_1.fsPath.basename(name, '.cmd') : name;
    var alias = m.alias;
    if (!common_1.R.is(Array, alias)) {
        alias = [alias];
    }
    alias = common_1.R.reject(common_1.R.isNil)(alias);
    var action = m.cmd || m.default;
    return {
        name: name,
        alias: alias,
        description: m.description,
        group: m.group,
        args: m.args,
        validate: m.validate,
        action: action,
    };
}
function toCommands(modulePaths) {
    var commands = modulePaths
        .map(toCommand)
        .filter(function (item) { return common_1.R.is(Function, item.action); });
    var result = {};
    commands.forEach(function (cmd) { return (result[cmd.name] = cmd); });
    return result;
}
function pathToCommands(path) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var paths;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, common_1.file.glob(path)];
                case 1:
                    paths = _a.sent();
                    return [2, toCommands(paths)];
            }
        });
    });
}
exports.default = (function (param) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var out, _i, param_1, path, _a;
    return tslib_1.__generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (!(typeof param === 'string')) return [3, 2];
                return [4, pathToCommands(param)];
            case 1:
                param = _b.sent();
                _b.label = 2;
            case 2:
                if (!Array.isArray(param)) return [3, 7];
                out = {};
                _i = 0, param_1 = param;
                _b.label = 3;
            case 3:
                if (!(_i < param_1.length)) return [3, 6];
                path = param_1[_i];
                _a = [{}, out];
                return [4, pathToCommands(path)];
            case 4:
                out = tslib_1.__assign.apply(void 0, _a.concat([(_b.sent())]));
                _b.label = 5;
            case 5:
                _i++;
                return [3, 3];
            case 6:
                param = out;
                _b.label = 7;
            case 7:
                command_1.default(param);
                return [2];
        }
    });
}); });
//# sourceMappingURL=init.js.map